package io.xjar.reflection;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;

public class XMethod
{
    private final Method method;
    
    XMethod(final Method method) {
        this.method = method;
    }
    
    public XValue invoke(final Object target, final Object... args) throws InvocationTargetException {
        try {
            return new XValue(this.method.invoke(target, args));
        }
        catch (final IllegalAccessException e) {
            throw new IllegalStateException(e);
        }
    }
    
    public Method method() {
        return this.method;
    }
}
